##
## Computes entropy of input text with models of order 0, 1, and 2
##
## Usage:  python3 entro.py <corpus.txt 


import sys
from math import log

## ----------------------------------
## Global variables 
t1={}  # character unigram counts
t2={}  # character bigram counts
t3={}  # character trigram counts
n=0    # total characters in text

## ---------------------------------
## increment (or initialize if needed) 
## the count of 'c' in table 't'
def increment(t,c): 
  if (c in t):
    t[c]=t[c]+1
  else:
    t[c]=1

## ---------------------------------
## Read input text and store occurrence count
## for each 1,2,3-gram in tables t1,t2,t3.
def readText() :
  global n,t1,t2,t3
  l1=sys.stdin.readline(); l1=l1.lower();
  while (l1!="##"):
    l2=sys.stdin.readline(); l2=l2.lower();
    if (l2=="") :
      l2="##"

    buff=l1+l2;  
    buff=buff.replace("\n","#")
    buff=buff.replace(" ","#");

    for i in range(0,len(l1)-1):
      increment(t1, buff[i])
      increment(t2, buff[i]+buff[i+1])
      increment(t3, buff[i]+buff[i+1]+buff[i+2])

    n=n+len(l1);
    l1=l2

## ----------- MAIN

## read text and count n-gram occurrences
readText()

## compute H0
????
sys.stdout.write("H0 = "+ ???? +"\n")

## compute H1
????
sys.stdout.write("H1 = "+ ???? +"\n")

## compute H2
????
sys.stdout.write("H2 = "+ ???? +"\n")

