##
## Loads a MLE trigram model, and uses it to generate
## sequences of given length.
##
##  Usage:   python3 generate.py model.dat length
##

import sys
import random

## ----------------------------------
## Global variables 
ug={}   # unigram set
ptr={}  # trigram probabilities
pini={} # initial probabilities

## ---------------------------------
## increment (or initialize if needed) in 'x'
## the count of 'c' in table 't'
def increment(t,c,x): 
  if (c in t):
    t[c]=t[c]+x
  else:
    t[c]=x

## ---------------------------------
## Load MLE model in given file into 'ptr'
def loadModel(fname) :
  # open file
  model = open(fname, encoding='utf-8')

  # load rest of lines into ptr
  lin=model.readline(); 
  tini=0
  while (lin!="") :
    t=lin.split(" ")
    ptr[t[0]] = float(t[1])

    # seen unigrams
    ug[t[0][0]] = 1;
    # sentence-starting characters 
    if (t[0][0]=="." and t[0][1]=="#"):
       increment(pini, t[0][2], float(t[2]))
       tini = tini + float(t[2])

    lin=model.readline();

  for i in pini :
    pini[i] = pini[i]/tini

## MAIN ---------------------

## -- load MLE trigram model
loadModel(sys.argv[1])
## length to generate
maxc = int(sys.argv[2])


x="."; y="#";  # initial state (sentece beggining, after a dot+space)

## select a random initial state ".#Z", according to initial 
## probabilities in pini.
z= ???
 
sys.stdout.write(z)
for i in range(1,maxc) :

  ## select a random next state, according to transition probabilities
  x=???; y=???; 
  z=???

  ## write character for selected state.
  if (z=="#") :
    sys.stdout.write(" ")
  else :
    sys.stdout.write(z)

sys.stdout.write("\n");
