
## Program that reads the output of clustering.cc and 
## prints a confusion table, plus Purity and Inverse Purity
##
##  usage:   ./clustering 5 < mydat | python3 pip.py

import sys

## ---------------------------------
## increment (or initialize if needed) in 'x'
## the count of 'c' in table 't'
def increment(t,c,x): 
  if (c in t):
    t[c]=t[c]+x
  else:
    t[c]=x

## -----  Global variables
count={}    # confusion counts
ntot=0      # read objects
classes={}  # seen classes
clusters={} # seen clusters

## ---- MAIN

## read and process input lines 

lin=sys.stdin.readline()
while (lin!=""):

   ## read line:  class + cluster
   t=lin.split()
   clas=t[0]
   clus=t[1]

   ## store list of seen classes and clusters
   increment(classes,clas,1)
   increment(clusters,clus,1)

   ## update counts
   increment(count, clas+"#"+clus, 1)
   ntot = ntot+1

   ## next element
   lin=sys.stdin.readline()


## ------- print confusion matrix
# matrix header
sys.stdout.write("   ")
for ct in sorted(clusters):
  sys.stdout.write(format(int(ct),"5d"))
sys.stdout.write("\n")
# matrix body
for cls in sorted(classes):
   sys.stdout.write(cls)
   for ct in sorted(clusters):
      if (cls+"#"+ct in count):
        sys.stdout.write(format(count[cls+"#"+ct],"5d"))
      else :
        sys.stdout.write("    0")
   sys.stdout.write("\n")


## --------- Compute and print Purity
????

## ----------- Compute and print Inverse Purity
????

