#ifndef TTCL_CL_CHOICES_HXX
#define TTCL_CL_CHOICES_HXX

// TTCL: The Template Clustering Library

/** @file
    Clustering - Choices
    @author Edgar Gonzalez i Pellicer
*/

#include <ttcl/co/array.hxx>
#include <ttcl/co/boost_matrix.hxx>
#include <ttcl/co/symmetric_matrix.hxx>
#include <ttcl/tu/choices.hxx>

/// TTCL Namespace
namespace ttcl {

  /// Clustering Namespace
  namespace cl {

    /// TTCL Array simmetric matrix
    template <typename Value>
    class ttcl_array_symmetric_matrix :
      public co::symmetric_matrix< co::array< Value > > {
    public:
      /// Base type
      typedef co::symmetric_matrix< co::array< Value > > base_type;
      
      /// Constructor
      ttcl_array_symmetric_matrix(const base_type& _size) :
	base_type(_size) {
      }
    };

    /// Distance matrix template
    /** Choice
     */
    ttcl_tu_choice_tem(distance_matrix_template, ttcl_array_symmetric_matrix);

    /// Hard Clustering Container
    /** Choice
     */
    ttcl_tu_choice(hard_clustering_container, co::array<int>);

    /// Soft Clustering Container
    /** Choice
     */
    ttcl_tu_choice(soft_clustering_container, co::boost_matrix<double>);
  }
}

#endif
