#ifndef _TTCL_CL_HARD_DISTANCE_CLUSTERER
#define _TTCL_CL_HARD_DISTANCE_CLUSTERER

// TTCL: The Template Clustering Library

/** @file
    Clustering - Hard distance clusterer
    @author Edgar Gonzalez i Pellicer
*/

#include <ttcl/cl/hard_data_clusterer.hxx>
#include <ttcl/tu/choices.hxx>

/// TTCL Namespace
namespace ttcl {

  /// Clustering Namespace
  namespace cl {

    /// Hard distance clusterer
    /** @param Data The data type
	@param Distance The distance type
    */
    template <typename Data,
	      typename Distance,
	      typename Choices = tu::default_choices>
    class hard_distance_clusterer :
      public hard_data_clusterer<Data, Choices> {
    public:
      /// Base type
      typedef hard_data_clusterer<Data, Choices> base_type;

      /// Distance type
      typedef Distance distance_type;
      
    protected:
      /// Distance
      distance_type distance_;

    public:
      /// Constructor
      hard_distance_clusterer(const distance_type& _distance) :
	distance_(_distance) {
      }
    };
  }
}
