#ifndef _TTCL_CL_SOFT_DISTANCE_CLUSTERER
#define _TTCL_CL_SOFT_DISTANCE_CLUSTERER

// TTCL: The Template Clustering Library

/** @file
    Clustering - Soft distance clusterer
    @author Edgar Gonzalez i Pellicer
*/

#include <ttcl/cl/soft_data_clusterer.hxx>
#include <ttcl/tu/choices.hxx>

/// TTCL Namespace
namespace ttcl {

  /// Clustering Namespace
  namespace cl {

    /// Soft distance clusterer
    /** @param Data The data type
	@param Distance The distance type
    */
    template <typename Data,
	      typename Distance,
	      typename Choices = tu::default_choices>
    class soft_distance_clusterer :
      public soft_data_clusterer<Data, Choices> {
    public:
      /// Base type
      typedef soft_data_clusterer<Data, Choices> base_type;

      /// Distance type
      typedef Distance distance_type;
      
    protected:
      /// Distance
      distance_type distance_;

    public:
      /// Constructor
      soft_distance_clusterer(const distance_type& _distance) :
	distance_(_distance) {
      }
    };
  }
}
