#ifndef TTCL_CR_CHOICES_HXX
#define TTCL_CR_CHOICES_HXX

// TTCL: The Template Clustering Library

/** @file
    Criteria - Choices
    @author Edgar Gonzlez i Pellicer
*/

#include <boost/multi_array.hpp>

#include <ttcl/tu/choices.hxx>
#include <ttcl/tu/tuning.hxx>

/// TTCL Namespace
namespace ttcl {

  /// Criteria Namespace
  namespace cr {

    /// Boost multi array
    template <typename Value>
    class boost_multi_array_2 :
      public boost::multi_array<Value, 2> {
    public:
      /// Constructor
      boost_multi_array_2(int _d1, int _d2) :
	boost::multi_array<Value, 2>(boost::extents[_d1][_d2]) {
      }
    };

    /// Criterion value type
    ttcl_tu_choice(criterion_value_type, double);

    /// Use non-clustered
    ttcl_tu_option(bool, use_non_clustered, true);

    /// Point to cluster matrix template
    ttcl_tu_choice_tem(point_to_cluster_template, boost_multi_array_2);
  }
}

#endif
