#ifndef _TTCL_HJ_HIER_DISTANCE_CLUSTERER
#define _TTCL_HJ_HIER_DISTANCE_CLUSTERER

// TTCL: The Template Clustering Library

/** @file
    Hierarchical Clustering - Distance clusterer base class
    @author Edgar Gonzalez i Pellicer
*/

#include <ttcl/hj/hier_data_clusterer.hxx>
#include <ttcl/tu/choices.hxx>

/// TTCL Namespace
namespace ttcl {

  /// Hierarchical Clustering Namespace
  namespace hj {

    /// Hierarchical distance clusterer base class
    template <typename Data,
	      typename Dist,
	      typename Choices = tu::default_choices>
    class hier_distance_clusterer :
      public hier_data_clusterer<Data, Choices> {
    public:
      /// Base type
      typedef hier_data_clusterer<Data, Choices> base_type;

      /// Distance type
      typedef Dist distance_type;
      
    protected:
      /// Distance
      distance_type distance_;

    public:
      /// Constructor
      hier_distance_clusterer(const distance_type& _distance) :
	distance_(_distance) {
      }
    };
  }
}

#endif
