#ifndef TTCL_UT_ANSI_HXX
#define TTCL_UT_ANSI_HXX

// TTCL: The Template Clustering Library

/** @file
    Utilities - ANSI-based colored output
    @author Edgar Gonzalez i Pellicer
*/

#include <iostream>

#include <ttcl/exception.hxx>

/// TTCL Namespace
namespace ttcl {

  /// Utility Namespace
  namespace ut { 

    /// ANSI-based colored output
    /** Enumeration
     */
    enum ansi {
      ansi_reset        = 0,
      ansi_bold         = 1,
      ansi_faint        = 2,
      ansi_italic       = 3,
      ansi_under_single = 4,
      ansi_blink_slow   = 5,
      ansi_blink_rapid  = 6,
      ansi_negative     = 7,
      ansi_conceal      = 8,
      ansi_under_double = 21,
      ansi_normal       = 22,
      ansi_under_no     = 24,
      ansi_blink_no     = 25,
      ansi_positive     = 27,
      ansi_reveal       = 28,
      ansi_fg_black     = 30,
      ansi_fg_red       = 31,
      ansi_fg_green     = 32,
      ansi_fg_yellow    = 33,
      ansi_fg_blue      = 34,
      ansi_fg_magenta   = 35,
      ansi_fg_cyan      = 36,
      ansi_fg_white     = 37,
      ansi_fg_reset     = 39,
      ansi_bg_black     = 40,
      ansi_bg_red       = 41,
      ansi_bg_green     = 42,
      ansi_bg_yellow    = 43,
      ansi_bg_blue      = 44,
      ansi_bg_magenta   = 45,
      ansi_bg_cyan      = 46,
      ansi_bg_white     = 47,
      ansi_bg_reset     = 49 };

    /// Send to some kind of stream
    template <typename T>
    T& operator<<(T& _stream, const ansi _sgr) {
      char buffer[16];
      std::snprintf(buffer, 16, "\033[%dm", _sgr);
      _stream << buffer;
      return _stream;
    }
  }
}

#endif
