#ifndef TTCL_UT_ARITHMETICAL_TRAITS_HXX
#define TTCL_UT_ARITHMETICAL_TRAITS_HXX

// TTCL: The Template Clustering Library

/** @file
    Utilities - Arithmetical traits
    @author Edgar Gonzalez i Pellicer
*/

/// TTCL Namespace
namespace ttcl {

  /// Utility Namespace
  namespace ut { 

    /// Arithmetical traits
    template <typename Value>
    class arithmetical_traits {
    public:
      /// Value type
      typedef Value value_type;

      /// Zero
      static value_type zero() {
	return value_type();
      }

      /// Zero
      static value_type& zero(value_type& _a) {
	return _a = value_type();
      }

      /// Addition
      template <typename Other>
      static value_type plus(const value_type& _a,
			     const Other& _b) {
	return _a + _b;
      }

      /// Addition
      template <typename Other>
      static value_type& plus_eq(value_type& _a,
				 const Other& _b) {
	return _a += _b;
      }
      
      /// Substraction
      template <typename Other>
      static value_type minus(const value_type& _a,
			      const Other& _b) {
	return _a - _b;
      }

      /// Substraction
      template <typename Other>
      static value_type& minus_eq(value_type& _a,
				  const Other& _b) {
	return _a -= _b;
      }

      /// Product
      template <typename Other>
      static value_type times(const value_type& _a,
			      const Other& _b) {
	return _a * _b;
      }

      /// Product
      template <typename Other>
      static value_type& times_eq(value_type& _a,
				  const Other& _b) {
	return _a *= _b;
      }

      /// Division
      template <typename Other>
      static value_type div(const value_type& _a,
			    const Other& _b) {
	return _a / _b;
      }

      /// Division
      template <typename Other>
      static value_type& div_eq(value_type& _a,
				const Other& _b) {
	return _a /= _b;
      }
    };
  }
}

#endif
