#ifndef TTCL_UT_TYPE_CONS_HXX
#define TTCL_UT_TYPE_CONS_HXX

// TTCL: The Template Clustering Library

/** @file
    Utilities - Cons-like operation for types
    @author Edgar Gonzlez i Pellicer
*/

#include <ttcl/ut/null_type.hxx>

/// TTCL Namespace
namespace ttcl {

  /// Utility Namespace
  namespace ut {

    /// Cons-like operation for types
    /** null_type works as an empty list
     */
    template <typename Head, typename Tail = null_type>
    struct type_cons {
      /// Head
      typedef Head head;

      /// Tail
      typedef Tail tail;
    };
  }
}

#endif
