#ifndef TTCL_WR_INTERFACE_WRAP_HXX
#define TTCL_WR_INTERFACE_WRAP_HXX

// TTCL: The Template Clustering Library

/** @file
    Wrappers - Base interface wrapper
    @author Edgar Gonzalez i Pellicer
*/

#include <ttcl/wr/shared_ptr.hxx>
#include <ttcl/wr/shared_referee.hxx>

/// TTCL Namespace
namespace ttcl {

  /// Wrapper Namespace
  namespace wr { 

    /// Base interface wrapper
    template <typename Interface = shared_referee>
    class interface_wrap {
    protected:
      /// Pointer
      ttcl::wr::shared_ptr<Interface> ptr_;
      
      /// Empty constructor
      interface_wrap() :
	ptr_() {
      }
	
      /// Constructor
      interface_wrap(Interface* _ptr) :
	ptr_(_ptr) {
      }
    };
  }
}

#endif
