#ifndef TTCL_WR_SHARED_REFEREE_HXX
#define TTCL_WR_SHARED_REFEREE_HXX

// TTCL: The Template Clustering Library

/** @file
    Wrappers - Shared referee base class
    @author Edgar Gonzalez i Pellicer
*/

#include <ttcl/types.hxx>

/// TTCL Namespace
namespace ttcl {

  /// Wrapper Namespace
  namespace wr {

    /// Shared referee base
    class shared_referee {
    protected:
      /// Bool owned
      bool owned_;

      /// Number of references
      uint references_;

    public:
      /// Constructor
      shared_referee(bool _owned = true, uint _references = 0) :
	owned_(_owned), references_(_references) {
      }

      /// Destructor
      virtual ~shared_referee() {
      }

      /// Add reference
      void add_reference() {
	++references_;
      }

      /// Del reference
      void del_reference() {
	if (--references_ == 0)
	  delete this;
      }
    };
  }
}

#endif
