#ifndef TTCL_WR_TYPED_SHARED_REFEREE_HXX
#define TTCL_WR_TYPED_SHARED_REFEREE_HXX

// TTCL: The Template Clustering Library

/** @file
    Wrappers - Typed shared referee mixin
    @author Edgar Gonzalez i Pellicer
*/

#include <ttcl/wr/shared_referee.hxx>

/// TTCL Namespace
namespace ttcl {

  /// Wrapper Namespace
  namespace wr { 

    /// Typed referee
    template <typename T, typename Base = shared_referee>
    class typed_shared_referee :
      public Base {
    public:
      /// Element type
      typedef T element_type;

      /// Base type
      typedef Base base_type;

    protected:
      /// Pointer
      element_type* ptr_;

    public:
      /// Constructor
      typed_shared_referee(element_type* _ptr = 0, bool _owned = true,
				uint _references = 0) :
	base_type(_owned, _references), ptr_(_ptr) {
      }

      /// Destructor
      virtual ~typed_shared_referee() {
	if (base_type::owned_)
	  delete ptr_;
      }
    };
  }
}

#endif
