#include <iostream>
#include <string>
#include <vector>

#include <ttcl/exception.hxx>
#include <ttcl/ut/binary_file.hxx>

ttcl_ut_binary_file_static;

int main(int argc, const char* argv[]) {
  try {
    ttcl::ut::binary_file bin;
    bin.open(argv[1]);

    std::string str;
    while (std::cin >> str) {
      ttcl::ut::binary_file::address addr =
	ttcl::ut::binary_file::parse(str);
      std::vector<ttcl::ut::binary_file::address_info> info = bin[addr];
      for (std::vector<ttcl::ut::binary_file::address_info>::iterator it =
	     info.begin(); it != info.end(); ++it)
	std::cout << it->file << ':' << it->line << ' '
		  << it->function << std::endl;
    }
  }
  catch (ttcl::exception& _e) {
    _e.display(std::cerr);
  }
}
