#include <iostream>

#include <vector>

#define BOOST_TEST_MAIN
#include <boost/test/included/unit_test.hpp>

// Number of points
const unsigned int n_points = 1000000;

// Disk vector
BOOST_AUTO_TEST_CASE( vector ) {
  // Create vector
  std::vector<unsigned int> vec1(n_points, 0);

  // Check initialization
  BOOST_REQUIRE_EQUAL(vec1.size(), n_points);
  for (unsigned int i = 0; i < n_points; ++i) 
    BOOST_CHECK_EQUAL(vec1[i], 0u);
  
  // Fill them
  for (unsigned int i = 0; i < n_points; ++i) {
    vec1[i] = i;
    BOOST_CHECK_EQUAL(vec1[i], i);
  }

  // Check it again
  for (unsigned int i = 0; i < n_points; ++i)
    BOOST_CHECK_EQUAL(vec1[i], i);
}

